#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
# vim: set fileencoding=UTF-8 :


__author__ = u"JaeHyuk Cho <minzkn@minzkn.com>"
__date__ = u"2020/09/08"
__version__ = u"0.0.0.1"


import logging
from requests import Request, Session


NAVER_CLIENT_ID = 'GrnNWcR0vi7v3Nop0NCX'
NAVER_CLIENT_SECRET = 'wxYrQnT49a'
REQUEST_URL = 'https://openapi.naver.com/v1/papago/n2mt'
REQUEST_HTTP_HEADERS = {
    'X-Naver-Client-Id': NAVER_CLIENT_ID,
    'X-Naver-Client-Secret': NAVER_CLIENT_SECRET,
}


def translate_line(line='', source='en', target='ko'):
    try:
        s = Session()

        payload = {
            'source': source,
            'target': target,
            'text': line,
        }

        req = Request('POST', REQUEST_URL, data=payload, headers=REQUEST_HTTP_HEADERS)
        prepped = req.prepare()
        res = s.send(prepped)
        res_json = res.json()

        return(res_json['message']['result']['translatedText'])
    except:
        return('<TRANSLATE ERROR>')


def translate_file(source, target):
    output = []
    with open(source, 'r') as f:
        for line in f.readlines():
            l = line.splitlines()
            if not l[0]:
                output.append('')
                continue

            tr = translate_line(l[0])

            output.append('IN: ' + l[0])
            output.append('TR: ' + tr)

    result = '\n'.join(output)
    logging.debug('OUTPUT {\n%s}'%(result))
    with open(target, 'w') as f:
        f.write(result)


def main():
    logging.basicConfig(level=logging.DEBUG, format='TRANSLATE: %(message)s')
    logging.debug('BEGIN translate')
    try:
        translate_file('yesterday.txt', 'yesterday_translated.txt')
    except:
        logging.debug('ERROR')
    logging.debug('END translate')


if __name__ == u"__main__":
    main()


# End of translate.py
